####################################################################
#
#	File:     djdpre.rb
#
#	Subject:  Part of a Ruby program to generate a program ("diffeq.---")
#                  to solve a system of ordinary differential equations
#                  with long Taylor series. Intended to Support
#                  programs with Ruby (native math) Ruby (APFP),
#                  Maple 12, maxima.
#                 It permits one to comment out blocks of code  between
#                    #DJDSTOP and #DJDSTART in a Ruby program.
#
#	Author:   Dennis J. Darland
#
#       Copyright (C) 2008-2012 Dennis J. Darland
#
#######################################################################
#######################################################################
# This file is part of omnisode.
#
#    omnisode is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
########################################################################
class Translate
  def initialize(it_in,it_out)
    @it_in = it_in
    #it_out = it_out
  end
  def it_in=(other)
    @it_in=other
  end
  def it_out=(other)
    @it_out=other
  end
  def it_in
    @it_in
  end
  def it_out
    @it_out
  end
end
def trans(line_in)
  cnt = 0
  line_in2 = line_in
  line_out = line_in
  while cnt < $cnt do
    if not line_out.nil? and not $tran_in[cnt].nil? and not $tran_out[cnt].nil? then

#      $stderr.puts "TRYING CHANGING entry_in = " + $tran_in[cnt] + " entry_out = " + $tran_out[cnt]
      line_out = line_in2.sub($tran_in[cnt],$tran_out[cnt])
      line_in2 = line_out
    end
    cnt += 1
  end
#  if line_in != line_out then
#    $stderr.puts "line CHANGED\n"
#  end
  return(line_out)
end
$tran_in = Array.new(2000)
$tran_out = Array.new(2000)
$cnt = 0
tran_fd = File.new("stree/russ.txt","r")
while line = tran_fd.gets do
#  $stderr.puts line
  if not line.nil? then
    it_in = line.chomp
    line = tran_fd.gets
    it_out = line.chomp
    $tran_in[$cnt] = it_in
    $tran_out[$cnt] = it_out
    $cnt += 1
#    $stderr.puts "it_in = " + it_in
#    $stderr.puts "it_out = " + it_out
  end
end

copy = 1
line_no = 0
in_cnt = 0
out_cnt = 0
line = $stdin.gets
while line
  line = line.chomp.rstrip
  line_no += 1
  if copy == 1 then
    puts trans(line)

    in_cnt += 1
    if line == "#DJDSTOP" then
      copy = 0
      $stderr.puts "STOPPED line = #{line_no}"
    end
    if line == "#DJDSTART"
      $stderr.puts "ALREADY STARTED line = #{line_no}"
    end
  else
    puts "# #{line}"
    out_cnt += 1
    if line == "#DJDSTART" then
      $stderr.puts "RESTARTED line = #{line_no}"
      copy = 1
    end
    if line == "#DJDSTOP" then
      $stderr.puts "ALREADY STOPPED line = #{line_no}"
    end
  end
  line = $stdin.gets
end
total = in_cnt + out_cnt
percent = in_cnt*100/total
$stderr.puts "Total in  = #{in_cnt}"
$stderr.puts "Total out = #{out_cnt}"
$stderr.puts "Total lines = #{total}"
$stderr.puts "#{percent}% completed"
