RNIL = false
LISTHEADER = 0
DECLARATION = 1
PARAMETER  = 2
RECORDELEMENT= 3
VARSIGNATURE = 4
VALSIGNATURE = 5
FUNCSIGNATURE = 6
TYPESIGNATURE = 7
TSCOMPONENT = 8
DEFCHARSIGS = 9
SIGNATURESIG = 10
BLOCKDENOTATION = 11
USELIST = 12
APPLICATION = 13
ENUMERATION = 14
EXTENSION = 15
PRODCONSTRUCTION = 16
RECORDCONSTRUCTION = 17
UNIONCONSTRUCTION = 18
WITHLIST = 19
MODPRIMARY = 20
EXPORTLIST = 21
HIDELIST = 22
EXPORTELEMENT =  23
ALLCONSTANTS = 24
WORDELSE = 25
WORDCAND = 26
WORDCOR = 27
GUARDEDLIST = 28
LOOPDENOTATION = 29
GUARDEDELEMENT = 30
OPRID = 31
LETTERID = 32
QSTR = 33
UQSTR = 34
FUNCCONSTR = 35
FREEVARNODE = 36
EXTERNDEF = 37
REXTERNDEF = 38
DCSEXCEPTION = 39
LASTKINDVALUE = 39
# for scanner -- anything??
STAR = 40
class NODE
  def initialize()
    @kind = false
    @vlineno = false
    @pre_num = false
    @post_num = false
    @lh_first = false
    @lh_last = false
  end
  #NODE
  #0
  def kind=(other)
    @kind =other
  end
  def kind
    @kind
  end
  def vlineno=(other)
    @vlineno =other
  end
  def vlineno
    @vlineno
  end
  def pre_num=(other)
    @pre_num =other
  end
  def pre_num
    @pre_num
  end
  def post_num=(other)
    @post_num =other
  end
  def post_num
    @post_num
  end
  def lh_first=(other)
    @lh_first =other
  end
  def lh_first
    @lh_first
  end
  def lh_last=(other)
    @lh_last =other
  end
  def lh_last
    @lh_last
  end
end
class NODE_Star < NODE
  def initialize()
    super()
    @kind =STAR
    @id_str_table_index =RNIL
  end
  def id_str_table_index=(other)
    @id_str_table_index=other
  end
  def id_str_table_index()
    @id_str_table_index
  end
end

class NODE_Declaration <NODE
  def initialize()
    super()
    @kind =DECLARATION
    @decl_id =false
    @decl_denotation =false
    @displacement =false
    @level =false
    @decl_signature =false
    @decl_sig_done =false
    @decl_previous_definition =false
    @decl_can_be_refd =false
    @decl_special =false
    @decl_sig_transp =false
    @decl_scope =false
    @decl_sel_index =false
    @decl_needed =false
    @decl_const_val =false
  end
  #DECLARATION
  #1
  def decl_id=(other)
    @decl_id =other
  end
  def decl_id
    @decl_id
  end
  def decl_denotation=(other)
    @decl_denotation =other
  end
  def decl_denotation
    @decl_denotation
  end
  def displacement=(other)
    @displacement =other
  end
  def displacement
    @displacement
  end
  def level=(other)
    @level =other
  end
  def level
    @level
  end
  def decl_signature=(other)
    @decl_signature =other
  end
  def decl_signature
    @decl_signature
  end
  def decl_sig_done=(other)
    @decl_sig_done =other
  end
  def decl_sig_done
    @decl_sig_done
  end
  def decl_sig_transp=(other)
    @decl_sig_transp =other
  end
  def decl_sig_transp
    @decl_sig_transp
  end
  @decl_innermost_id =false
  def decl_innermost_id=(other)
    @decl_innermost_id =other
  end
  def decl_innermost_id
    @decl_innermost_id
  end
  def decl_previous_definition=(other)
    @decl_previous_definition =other
  end
  def decl_previous_definition
    @decl_previous_definition
  end
  def decl_scope=(other)
    @decl_scope =other
  end
  def decl_scope
    @decl_scope
  end
  def decl_can_be_refd=(other)
    @decl_can_be_refd =other
  end
  def decl_can_be_refd
    @decl_can_be_refd
  end
  def decl_special=(other)
    @decl_special =other
  end
  def decl_special
    @decl_special
  end
  def decl_sel_index=(other)
    @decl_sel_index =other
  end
  def decl_sel_index
    @decl_sel_index
  end
  def decl_needed=(other)
    @decl_needed =other
  end
  def decl_needed
    @decl_needed
  end
  def decl_const_val=(other)
    @decl_const_val =other
  end
  def decl_const_val
    @decl_const_val
  end
end
class NODE_Parameter <NODE
  def initialize()
    super()
    @kind =PARAMETER
    @par_id =false
    @par_signature =false
    @displacement =false
    @level =false
    @par_previous_definition =false
    @par_scope =false
    @par_only_def =false
  end
  #PARAMETER
  #2
  def par_id=(other)
    @par_id =other
  end
  def par_id
    @par_id
  end
  def par_signature=(other)
    @par_signature =other
  end
  def par_signature
    @par_signature
  end
  def displacement=(other)
    @displacement =other
  end
  def displacement
    @displacement
  end
  def level=(other)
    @level =other
  end
  def level
    @level
  end
  def par_previous_definition=(other)
    @par_previous_definition =other
  end
  def par_previous_definition
    @par_previous_definition
  end
  def par_scope=(other)
    @par_scope =other
  end
  def par_scope
    @par_scope
  end
  def par_only_def=(other)
    @par_only_def =other
  end
  def par_only_def
    @par_only_def
  end
end
class NODE_RElement <NODE
  def initialize()
    super()
    @kind =RECORDELEMENT
    @re_id =false
    @re_denotation =false
    @re_New_index =false
    @re_ValueOf_index =false
    @re_assign_index =false
  end
  #RECORDELEMENT
  #3
  def re_id=(other)
    @re_id =other
  end
  def re_id
    @re_id
  end
  def re_denotation=(other)
    @re_denotation =other
  end
  def re_denotation
    @re_denotation
  end
  def re_New_index=(other)
    @re_New_index =other
  end
  def re_New_index
    @re_New_index
  end
  def re_ValueOf_index=(other)
    @re_ValueOf_index =other
  end
  def re_ValueOf_index
    @re_ValueOf_index
  end
  def re_assign_index=(other)
    @re_assign_index =other
  end
  def re_assign_index
    @re_assign_index
  end
end
class NODE_VarSignature <NODE
  def initialize()
    super()
    @kind =VARSIGNATURE
    @signature =false
    @sig_done =false
    @var_denotation =false
  end
  #VARSIGNATURE
  #4
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def var_denotation=(other)
    @var_denotation =other
  end
  def var_denotation
    @var_denotation
  end
end
class NODE_ValSignature <NODE
  def initialize()
    super()
    @kind =VALSIGNATURE
    @signature =false
    @sig_done =false
    @val_denotation =false
  end
  #VALSIGNATURE
  #5
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def val_denotation=(other)
    @val_denotation =other
  end
  def val_denotation
    @val_denotation
  end
end

class NODE_FSignature <NODE
  def initialize()
    super()
    @kind =FUNCSIGNATURE
    @signature =false
    @sig_done =false
    @fsig_construction =false
    @fsig_special =false
    @fsig_slink_known =false
    @fsig_inline_code =false
    @fsig_param_list =false
    @fsig_result_sig =false

  end
  #FUNCSIGNATURE
  #6
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def fsig_construction=(other)
    @fsig_construction =other
  end
  def fsig_construction
    @fsig_construction
  end
  def fsig_special=(other)
    @fsig_special =other
  end
  def fsig_special
    @fsig_special
  end
  def fsig_slink_known=(other)
    @fsig_slink_known =other
  end
  def fsig_slink_known
    @fsig_slink_known
  end
  def fsig_inline_code=(other)
    @fsig_inline_code =other
  end
  def fsig_inline_code
    @fsig_inline_code
  end
  def fsig_param_list=(other)
    @fsig_param_list =other
  end
  def fsig_param_list
    @fsig_param_list
  end
  def fsig_result_sig=(other)
    @fsig_result_sig =other
  end
  def fsig_result_sig
    @fsig_result_sig
  end
end
class NODE_TSignature <NODE
  def initialize()
    super()
    @kind =TYPESIGNATURE
    @signature =false
    @sig_done =false
    @ts_simple_type =false
    @ts_local_type_id =false
    @ts_clist =false
    @ts_previous_definition =false
    @ts_const_code =false
    @ts_string_code =false
    @ts_element_code =false
    @ts_string_max =false
    @ts_meta_concat =false

  end
  #TYPESIGNATURE
  #7
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def ts_simple_type=(other)
    @ts_simple_type =other
  end
  def ts_simple_type
    @ts_simple_type
  end
  def ts_local_type_id=(other)
    @ts_local_type_id =other
  end
  def ts_local_type_id
    @ts_local_type_id
  end
  def ts_clist=(other)
    @ts_clist =other
  end
  def ts_clist
    @ts_clist
  end
  def ts_previous_definition=(other)
    @ts_previous_definition =other
  end
  def ts_previous_definition
    @ts_previous_definition
  end
  def ts_const_code=(other)
    @ts_const_code =other
  end
  def ts_const_code
    @ts_const_code
  end
  def ts_string_code=(other)
    @ts_string_code =other
  end
  def ts_string_code
    @ts_string_code
  end
  def ts_element_code=(other)
    @ts_element_code =other
  end
  def ts_element_code
    @ts_element_code
  end
  def ts_string_max=(other)
    @ts_string_max =other
  end
  def ts_string_max
    @ts_string_max
  end
  def ts_meta_concat=(other)
    @ts_meta_concat =other
  end
  def ts_meta_concat
    @ts_meta_concat
  end
end
class NODE_TSComponent <NODE
  def initialize()
    super()
    @kind =TSCOMPONENT
    @tsc_id =false
    @tsc_signature =false
  end
  #TSCOMPONENT
  #8
  def tsc_id=(other)
    @tsc_id =other
  end
  def tsc_id
    @tsc_id
  end
  def tsc_signature=(other)
    @tsc_signature =other
  end
  def tsc_signature
    @tsc_signature
  end
end
class NODE_DefCharSigs <NODE
  def initialize()
    super()
    @kind =DEFCHARSIGS
    @dcs_0 =false
    @dcs_1 =false
    @dcs_2 =false
    @dcs_3 =false
    @dcs_exceptions =false
  end
  #DEFCHARSIGS
  #9
  def dcs_0=(other)
    @dcs_0 =other
  end
  def dcs_0
    @dcs_0
  end
  def dcs_1=(other)
    @dcs_1 =other
  end
  def dcs_1
    @dcs_1
  end
  def dcs_2=(other)
    @dcs_2 =other
  end
  def dcs_2
    @dcs_2
  end
  def dcs_3=(other)
    @dcs_3 =other
  end
  def dcs_3
    @dcs_3
  end
  def dcs_exceptions=(other)
    @dcs_exceptions =other
  end
  def dcs_exceptions
    @dcs_exceptions
  end
end
class NODE_SignatureSig <NODE
  def initialize()
    super()
    @kind =SIGNATURESIG
    @signature =false
    @sig_done =false
  end
  #SIGNATURESIG
  #10
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
end
class NODE_BlDenotation <NODE
  def initialize()
    super()
    @kind =BLOCKDENOTATION
    @signature =false
    @sig_done =false
    @ar_size =false
    @ar_static_link =false
    @ar_static_level =false
    @bld_declaration_list =false
    @bld_den_seq =false
    @bld_precedence =false
    @bld_flags =false
  end
  #BLOCKDENOTATION
  #11
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def ar_size=(other)
    @ar_size =other
  end
  def ar_size
    @ar_size
  end
  def ar_static_link=(other)
    @ar_static_link =other
  end
  def ar_static_link
    @ar_static_link
  end
  def ar_static_level=(other)
    @ar_static_level =other
  end
  def ar_static_level
    @ar_static_level
  end
  def bld_declaration_list=(other)
    @bld_declaration_list =other
  end
  def bld_declaration_list
    @bld_declaration_list
  end
  def bld_den_seq=(other)
    @bld_den_seq =other
  end
  def bld_den_seq
    @bld_den_seq
  end
  def bld_precedence=(other)
    @bld_precedence =other
  end
  def bld_precedence
    @bld_precedence
  end
  def bld_flags=(other)
    @bld_flags =other
  end
  def bld_flags
    @bld_flags
  end
end
class NODE_UseList <NODE
  def initialize()
    super()
    @kind =USELIST
    @signature =false
    @sig_done =false
    @usl_type_list =false
    @usl_den_seq =false
    @usl_previous_list =false
    @usl_precedence =false

  end
  #USELIST
  #12
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def usl_type_list=(other)
    @usl_type_list =other
  end
  def usl_type_list
    @usl_type_list
  end
  def usl_den_seq=(other)
    @usl_den_seq =other
  end
  def usl_den_seq
    @usl_den_seq
  end
  def usl_previous_list=(other)
    @usl_previous_list =other
  end
  def usl_previous_list
    @usl_previous_list
  end
  def usl_precedence=(other)
    @usl_precedence =other
  end
  def usl_precedence
    @usl_precedence
  end
end
class NODE_Application <NODE
  def initialize()
    super()
    @kind =APPLICATION
    @signature =false
    @sig_done =false
    @ap_operator =false
    @ap_args =false
    @ap_void_decl =false
  end
  #APPLICATION
  #13
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def ap_operator=(other)
    @ap_operator =other
  end
  def ap_operator
    @ap_operator
  end
  def ap_args=(other)
    @ap_args =other
  end
  def ap_args
    @ap_args
  end
  def ap_void_decl=(other)
    @ap_void_decl =other
  end
  def ap_void_decl
    @ap_void_decl
  end
end
class NODE_Enumeration <NODE
  def initialize()
    super()
    @kind =ENUMERATION
    @signature =false
    @sig_done =false
    @enum_id_list =false
  end
  #ENUMERATION
  #14
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def enum_id_list=(other)
    @enum_id_list =other
  end
  def enum_id_list
    @enum_id_list
  end
end
class NODE_Extension <NODE
  def initialize()
    super()
    @kind =EXTENSION
    @signature =false
    @sig_done =false
    @ext_denotation =false
    @iIn_index =false
    @oOut_index =false
  end
  #EXTENSION
  #15
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def ext_denotation=(other)
    @ext_denotation =other
  end
  def ext_denotation
    @ext_denotation
  end
  def iIn_index=(other)
    @iIn_index =other
  end
  def iIn_index
    @iIn_index
  end
  @oOut_index =false
  def oOut_index=(other)
    @oOut_index =other
  end
  def oOut_index
    @oOut_index
  end
end
class NODE_Product <NODE
  def initialize()
    super()
    @kind =PRODCONSTRUCTION
    @signature =false
    @sig_done =false
    @prod_local_type_id =false
    @prod_components =false
    @prod_previous_definition =false
  end
  #PRODCONSTRUCTION
  #16
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def prod_local_type_id=(other)
    @prod_local_type_id =other
  end
  def prod_local_type_id
    @prod_local_type_id
  end
  def prod_components=(other)
    @prod_components =other
  end
  def prod_components
    @prod_components
  end
  def prod_previous_definition=(other)
    @prod_previous_definition =other
  end
  def prod_previous_definition
    @prod_previous_definition
  end
end
class NODE_Record <NODE
  def initialize()
    super()
    @kind =RECORDCONSTRUCTION
    @signature =false
    @sig_done =false
    @rec_component_list =false
    @rec_previous_definition =false
  end
  #RECORDCONSTRUCTION
  #17
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def rec_component_list=(other)
    @rec_component_list =other
  end
  def rec_component_list
    @rec_component_list
  end
  def rec_previous_definition=(other)
    @rec_previous_definition =other
  end
  def rec_previous_definition
    @rec_previous_definition
  end
end
class NODE_Union <NODE
  def initialize()
    super()
    @kind =UNIONCONSTRUCTION
    @signature =false
    @sig_done =false
    @prod_local_type_id =false
    @prod_components =false
    @prod_previous_definition =false
    @sel_type =false # added djd - not sure belong yyyiii   sspppp
  end
  #UNIONCONSTRUCTION
  #18
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def prod_local_type_id=(other)
    @prod_local_type_id =other
  end
  def prod_local_type_id
    @prod_local_type_id
  end
  def prod_components=(other)
    @prod_components =other
  end
  def prod_components
    @prod_components
  end
  def prod_previous_definition=(other)
    @prod_previous_definition =other
  end
  def prod_previous_definition
    @prod_previous_definition
  end
###DJDSTOP
  def sel_type=(other)
    @sel_type =other
  end
  def sel_type
    @sel_type
  end
###DJDSTART
end
class NODE_WithList <NODE
  def initialize()
    super()
    @kind =WITHLIST
    @wl_local_type_id =false
    @wl_component_list =false
    @wl_previous_definition =false
  end
  #WITHLIST
  #19
  def wl_local_type_id=(other)
    @wl_local_type_id =other
  end
  def wl_local_type_id
    @wl_local_type_id
  end
  def wl_component_list=(other)
    @wl_component_list =other
  end
  def wl_component_list
    @wl_component_list
  end
  def wl_previous_definition=(other)
    @wl_previous_definition =other
  end
  def wl_previous_definition
    @wl_previous_definition
  end
end
class NODE_MPrimary <NODE
  def initialize()
    super()
    @kind =MODPRIMARY
    @signature =false
    @sig_done =false
    @displacement =false
    @level =false
    @mp_primary =false
    @mp_type_modifier =false
    @mp_delete_v =false
    @mp_orig_length =false
    @mp_needed =false
    @mp_no_surr_loop =false
  end
  #MODPRIMARY
  #20
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def displacement=(other)
    @displacement =other
  end
  def displacement
    @displacement
  end
  def level=(other)
    @level =other
  end
  def level
    @level
  end
  def mp_primary=(other)
    @mp_primary =other
  end
  def mp_primary
    @mp_primary
  end
  def mp_type_modifier=(other)
    @mp_type_modifier =other
  end
  def mp_type_modifier
    @mp_type_modifier
  end
  def mp_delete_v=(other)
    @mp_delete_v =other
  end
  def mp_delete_v
    @mp_delete_v
  end
  def mp_orig_length=(other)
    @mp_orig_length =other
  end
  def mp_orig_length
    @mp_orig_length
  end
  def mp_needed=(other)
    @mp_needed =other
  end
  def mp_needed
    @mp_needed
  end
  def mp_no_surr_loop=(other)
    @mp_no_surr_loop =other
  end
  def mp_no_surr_loop
    @mp_no_surr_loop
  end
end
class NODE_Elist <NODE
  def initialize()
    super()
    @kind =EXPORTLIST
    @el_local_type_id =false
    @el_export_element_list =false
    @el_previous_definition =false
  end
  #EXPORTLIST
  #21
  def el_local_type_id=(other)
    @el_local_type_id =other
  end
  def el_local_type_id
    @el_local_type_id
  end
  def el_export_element_list=(other)
    @el_export_element_list =other
  end
  def el_export_element_list
    @el_export_element_list
  end
  def el_previous_definition=(other)
    @el_previous_definition =other
  end
  def el_previous_definition
    @el_previous_definition
  end
end
class NODE_Hlist <NODE
  def initialize()
    super()
    @kind =HIDELIST
    @el_local_type_id =false
    @el_export_element_list =false
    @el_previous_definition =false
  end
  #HIDELIST
  #22
  def el_local_type_id=(other)
    @el_local_type_id =other
  end
  def el_local_type_id
    @el_local_type_id
  end
  def el_export_element_list=(other)
    @el_export_element_list =other
  end
  def el_export_element_list
    @el_export_element_list
  end
  def el_previous_definition=(other)
    @el_previous_definition =other
  end
  def el_previous_definition
    @el_previous_definition
  end
end
class NODE_EElement <NODE
  def initialize()
    super()
    @kind =EXPORTELEMENT
    @ee_id =false
    @ee_signature =false
    @ee_export_list =false
  end
  #EXPORTELEMENT
  #23
  def ee_id=(other)
    @ee_id =other
  end
  def ee_id
    @ee_id
  end
  def ee_signature=(other)
    @ee_signature =other
  end
  def ee_signature
    @ee_signature
  end
  def ee_export_list=(other)
    @ee_export_list =other
  end
  def ee_export_list
    @ee_export_list
  end
end
class NODE_ConstsKeyWord <NODE
  def initialize()
    super()
    @kind =ALLCONSTANTS
  end
  #ALLCONSTANTS
  #24
end
class NODE_ElseKeyWord <NODE
  def initialize()
    super()
    @kind =WORDELSE
    @signature =false
    @sig_done =false
  end
  #WORDELSE
  #25
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
end
class NODE_CandKeyWord <NODE
  def initialize()
    super()
    @kind =WORDCAND
  end
  #WORDCAND
  #26
end
class NODE_CorKeyWord <NODE
  def initialize()
    super()
    @kind =WORDCOR
  end
  #WORDCOR
  #27
end
class NODE_GList <NODE
  def initialize()
    super()
    @kind =GUARDEDLIST
    @signature =false
    @sig_done =false
    @gl_list =false
  end
  #GUARDEDLIST
  #28
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def gl_list=(other)
    @gl_list =other
  end
  def gl_list
    @gl_list
  end
end
class NODE_LDenotation <NODE
  def initialize()
    super()
    @kind =LOOPDENOTATION
    @signature =false
    @sig_done =false
    @gl_list =false
  end
  #LOOPDENOTATION
  #29
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def gl_list=(other)
    @gl_list =other
  end
  def gl_list
    @gl_list
  end
end
class NODE_GElement <NODE
  def initialize()
    super()
    @kind =GUARDEDELEMENT
    @ge_guard =false
    @ge_element =false
  end
  #GUARDEDELEMENT
  #30
  def ge_guard=(other)
    @ge_guard =other
  end
  def ge_guard
    @ge_guard
  end
  def ge_element=(other)
    @ge_element =other
  end
  def ge_element
    @ge_element
  end
end
class NODE_OpId <NODE
  def initialize()
    super()
    @kind =OPRID
    @signature =false
    @sig_done =false
    @sel_type =false
    @id_str_table_index =false
    @id_use_list =false
    @id_def_found =false
    @sel_index =false
    @id_appl =false
    @id_forward_ref =false
  end
  #OPRID
  #31
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def sel_type=(other)
    @sel_type =other
  end
  def sel_type
    @sel_type
  end
  def id_str_table_index=(other)
    @id_str_table_index =other
  end
  def id_str_table_index
    @id_str_table_index
  end
  def id_use_list=(other)
    @id_use_list =other
  end
  def id_use_list
    @id_use_list
  end
  @id_last_definition =false
  def id_last_definition=(other)
    @id_last_definition =other
  end
  def id_last_definition
    @id_last_definition
  end
  def id_def_found=(other)
    @id_def_found =other
  end
  def id_def_found
    @id_def_found
  end
  def sel_index=(other)
    @sel_index =other
  end
  def sel_index
    @sel_index
  end
  def id_appl=(other)
    @id_appl =other
  end
  def id_appl
    @id_appl
  end
  def id_forward_ref=(other)
    @id_forward_ref =other
  end
  def id_forward_ref
    @id_forward_ref
  end
end
class NODE_LetterId <NODE
  def initialize()
    super()
    @kind =LETTERID
    @signature =false
    @sig_done =false
    @sel_type =false
    @id_str_table_index =false
    @id_use_list =false
    @id_last_definition =false
    @id_def_found =false
    @sel_index =false
    @id_appl =false
    @id_forward_ref =false
  end
  #LETTERID
  #32
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def sel_type=(other)
    @sel_type =other
  end
  def sel_type
    @sel_type
  end
  def id_str_table_index=(other)
    @id_str_table_index =other
  end
  def id_str_table_index
    @id_str_table_index
  end
  def id_use_list=(other)
    @id_use_list =other
  end
  def id_use_list
    @id_use_list
  end
  def id_last_definition=(other)
    @id_last_definition =other
  end
  def id_last_definition
    @id_last_definition
  end
  def id_def_found=(other)
    @id_def_found =other
  end
  def id_def_found
    @id_def_found
  end
  def sel_index=(other)
    @sel_index =other
  end
  def sel_index
    @sel_index
  end
  def id_appl=(other)
    @id_appl =other
  end
  def id_appl
    @id_appl
  end
  def id_forward_ref=(other)
    @id_forward_ref =other
  end
  def id_forward_ref
    @id_forward_ref
  end
end
class NODE_QStr <NODE
  def initialize()
    super()
    @kind =QSTR
    @signature =false
    @sig_done =false
    @sel_type =false
    @str_string =false
    @str_use_list =false
    @str_expansion =false
  end
  #QSTR
  #33
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def sel_type=(other)
    @sel_type =other
  end
  def sel_type
    @sel_type
  end
  def str_string=(other)
    @str_string =other
  end
  def str_string
    @str_string
  end
  def str_use_list=(other)
    @str_use_list =other
  end
  def str_use_list
    @str_use_list
  end
  def str_expansion=(other)
    @str_expansion =other
  end
  def str_expansion
    @str_expansion
  end
end
class NODE_UQStr <NODE
  def initialize()
    super()
    @kind =UQSTR
    @signature =false
    @sig_done =false
    @sel_type =false
    @str_string =false
    @str_use_list =false
    @str_expansion =false
  end
  #UQSTR
  #34
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def sel_type=(other)
    @sel_type =other
  end
  def sel_type
    @sel_type
  end
  def str_string=(other)
    @str_string =other
  end
  def str_string
    @str_string
  end
  def str_use_list=(other)
    @str_use_list =other
  end
  def str_use_list
    @str_use_list
  end
  def str_expansion=(other)
    @str_expansion =other
  end
  def str_expansion
    @str_expansion
  end
end
class NODE_FConstruction <NODE
  def initialize()
    super()
    @kind =FUNCCONSTR
    @signature =false
    @sig_done =false
    @ar_size =false
    @ar_static_link =false
    @ar_static_level =false
    @fc_body =false
    @fc_complexity =false
    @fc_code_label =false
    @fc_free_vars =false
    @fc_body_needed =false
  end
  #FUNCCONSTR
  #35
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def ar_size=(other)
    @ar_size =other
  end
  def ar_size
    @ar_size
  end
  def ar_static_link=(other)
    @ar_static_link =other
  end
  def ar_static_link
    @ar_static_link
  end
  def ar_static_level=(other)
    @ar_static_level =other
  end
  def ar_static_level
    @ar_static_level
  end
  def fc_body=(other)
    @fc_body =other
  end
  def fc_body
    @fc_body
  end
  def fc_complexity=(other)
    @fc_complexity =other
  end
  def fc_complexity
    @fc_complexity
  end
  def fc_code_label=(other)
    @fc_code_label =other
  end
  def fc_code_label
    @fc_code_label
  end
  def fc_free_vars=(other)
    @fc_free_vars =other
  end
  def fc_free_vars
    @fc_free_vars
  end
  def fc_body_needed=(other)
    @fc_body_needed =other
  end
  def fc_body_needed
    @fc_body_needed
  end
end
class NODE_FreeVarNode <NODE
  def initialize()
    super()
    @kind =FREEVARNODE
    @fv_last_definition =false
    @fv_surr_class =false
    @fv_surr_index =false
    @fv_index =false
  end
  #FREEVARNODE
  #36
  def fv_last_definition=(other)
    @fv_last_definition =other
  end
  def fv_last_definition
    @fv_last_definition
  end
  def fv_surr_class=(other)
    @fv_surr_class =other
  end
  def fv_surr_class
    @fv_surr_class
  end
  def fv_surr_index=(other)
    @fv_surr_index =other
  end
  def fv_surr_index
    @fv_surr_index
  end
  def fv_index=(other)
    @fv_index =other
  end
  def fv_index
    @fv_index
  end
end
class NODE_ExternDef <NODE
  def initialize()
    super()
    @kind =EXTERNDEF
    @ext_name =false
  end
  #EXTERNDEF
  #37
  def ext_name=(other)
    @ext_name =other
  end
  def ext_name
    @ext_name
  end
end
class NODE_RExternDef <NODE
  def initialize()
    super()
    @kind =REXTERNDEF
    @signature =false
    @sig_done =false
    @r_ext_name =false
  end
  #REXTERNDEF
  #38
  def signature=(other)
    @signature =other
  end
  def signature
    @signature
  end
  def sig_done=(other)
    @sig_done =other
  end
  def sig_done
    @sig_done
  end
  def r_ext_name=(other)
    @r_ext_name =other
  end
  def r_ext_name
    @r_ext_name
  end
end
class NODE_DCSException < NODE
  def initialize()
    super()
    @kind =DCSEXCEPTION
    @dcse_char =false
    @dcse_inline =false
    @dcse_special =false
    @dcse_construction =false
  end
  #DCSEXCEPTION
  #39
  def dcse_char=(other)
    @dcse_char =other
  end
  def dcse_char
    @dcse_char
  end
  def dcse_inline=(other)
    @dcse_inline =other
  end
  def dcse_inline
    @dcse_inline
  end
  def dcse_special=(other)
    @dcse_special =other
  end
  def dcse_special
    @dcse_special
  end
  def dcse_construction=(other)
    @dcse_construction =other
  end
  def dcse_construction
    @dcse_construction
  end
end
