def initids()
  if VERBOSE then
    $stderr.puts "Entering initids"
  end

  #    NODE *   var_param,
  #         *   val_param,
  #         *   as_params,
  #         *   two_params,
  #         *   al_params;
  $var_param = NODE.new()
  $val_param = NODE.new()
  $as_params = NODE.new()
  $two_params = NODE.new()
  $al_params = NODE.new()
  $yyvline = 9999
  $pend = Array.new(NLEVELS) #   /* $pend[n] = last string table entry with precedence */

  #    /* initialize string table indicees */
  stt_enter("?")  # /* Make sure index 0 is not used */
  $indx_passign = stt_enter("+=")
  $indx_massign = stt_enter("-=")
  if VERBOSE then
    $stderr.puts "$stt_size = " + $stt_size.to_s + "$stt_ptr = " + $stt_ptr.to_s
  end
  $indx_assign = $pend[0] = stt_enter(":=")
  $indx_or = $pend[1] = $pend[2] = $pend[3] = $pend[4] = stt_enter("or")
  $indx_and = $pend[5] = stt_enter("and")
  $indx_not = $pend[6] = stt_enter("not")
  $indx_equals = stt_enter("=")
  $indx_less = stt_enter("<")
  $indx_le = stt_enter("<=")
  $indx_ge = stt_enter(">=")
  $indx_ne = stt_enter("<>")
  $indx_greater = $pend[7] = stt_enter(">"  )
  $indx_plus = stt_enter("+")
  $indx_minus = $pend[8] = stt_enter("-")
  $indx_times = stt_enter("*")
  $indx_divide = stt_enter("/")
  $indx_mod = $pend[9] = stt_enter("%")
  $indx_pconc = stt_enter("^+")
  $indx_sconc = $pend[10] = stt_enter("^*")
  $indx_exp = $pend[11] = stt_enter("**")
  $indx_deref = $pend[12] = stt_enter("^")
  $indx_subscr = $pend[13] = stt_enter(".")
  $indx_New = stt_enter("New")
  $indx_ptr_New = stt_enter("ptr_New")
  $indx_init_New = stt_enter("init_New")
  $indx_ValueOf = stt_enter("V")
  $indx_First = stt_enter("First")
  $indx_Last = stt_enter("Last")
  $indx_Pred = stt_enter("Pred")
  $indx_Succ = stt_enter("Succ")
  $indx_Ord = stt_enter("Ord")
  $indx_OrdInv = stt_enter("OrdInv")
  $indx_Card = stt_enter("Card")
  $indx_In = stt_enter("In")
  $indx_Out = stt_enter("Out")
  $indx_Boolean = stt_enter("Boolean")
  $indx_true = stt_enter("True")
  $indx_false = stt_enter("False")
  $indx_Integer = stt_enter("Short")
  $indx_Void = stt_enter("Void")
  $indx_Array = stt_enter("Array")
  $indx_put = stt_enter("put")
  $indx_Callcc = stt_enter("Callcc")
  $indx_size = stt_enter("size")
  $indx_empty = stt_enter("''")
  $indx_simple = stt_enter("simple")
  $indx_standard = stt_enter("standard")
  $indx_inline = stt_enter("inline")
  $indx_Mk = stt_enter("Mk")
  $indx_Null = stt_enter("Null")
#  if VERBOSE then
#    $stderr.puts "$stt_size = " + $stt_size.to_s + "$stt_ptr = " + $stt_ptr.to_s
#  end
  $id_Boolean = mknode(LETTERID, $indx_Boolean)
  $id_Void = mknode(LETTERID, $indx_Void)
  $id_Integer = mknode(LETTERID, $indx_Integer)
  $id_put = mknode(LETTERID, $indx_put)
  $id_ValueOf = mknode(LETTERID, $indx_ValueOf)
  $id_New = mknode(LETTERID, $indx_New)
  $id_size = mknode(LETTERID, $indx_size)
  $id_Null = mknode(LETTERID, $indx_Null)
  $id_times = mknode(LETTERID, $indx_times)
  $id_plus = mknode(LETTERID, $indx_plus)
#DJDSTOP
# 
#   /* initialize default signatures */
#   /* Note that since these can and will be shared they should not */
#   /* be touched by the symbol table routine */
# #DJDSTART
  $val_Boolean = lock( mknode(VALSIGNATURE,
                             $id_Boolean)
                      )
  $val_Integer = lock( mknode(VALSIGNATURE,
                             $id_Integer)
                      )
  $val_Void    = lock( mknode(VALSIGNATURE,
                             $id_Void)
                      )
  $var_Void    = lock( mknode(VARSIGNATURE,
                             $id_Void)
                      )

  $val_param = lock( mknode(PARAMETER,
                           RNIL,
                           mknode(VALSIGNATURE,
                                  mknode(LETTERID,-1)
                                  )
                           ) )

  $var_param = lock( mknode(PARAMETER,
                           RNIL,
                           mknode(VARSIGNATURE,
                                  mknode(LETTERID,-1)
                                  )
                           ) )

  $as_params = lock( mklist($var_param, $val_param, -1) )
  $two_params = lock( mklist($val_param, $val_param, -1) )
  $al_params = lock(mklist($var_param, $var_param, -1) )

  $sig_assign = lock( mknode(FUNCSIGNATURE, RNIL, $as_params,
                            $val_param[0].par_signature) )

  $sig_pconc =
   $sig_sconc =
    lock( mknode(FUNCSIGNATURE, RNIL, $two_params,
                 $val_param[0].par_signature))

  $sig_equals =
    $sig_less =
    $sig_greater =
    lock( mknode(FUNCSIGNATURE, RNIL, $two_params,$val_Boolean) )
  $sig_New = lock( mknode(FUNCSIGNATURE, RNIL, emptylist(),
                         $var_param[0] . par_signature) )
  $sig_const = lock( mknode(FUNCSIGNATURE, RNIL, emptylist(),
                           $val_param[0] . par_signature) )
  $sig_ValueOf = lock( mknode(FUNCSIGNATURE, RNIL,
                             mklist($var_param, -1),
			     $val_param[0] . par_signature) )
  $sig_Signature = lock(mknode(SIGNATURESIG))

  $sel_true = mknode(LETTERID,$indx_true)

  #        initfld(&(sel_true.sel_type),id_Boolean)
  initfld(($sel_true[0].sel_type),$id_Boolean)

  $sel_true = mknode(APPLICATION, $sel_true, emptylist())
  lock( $sel_true )

  $sel_false = mknode(LETTERID,$indx_false)
  #        initfld(&(sel_false.sel_type),id_Boolean)
  initfld(($sel_false[0].sel_type),$id_Boolean)
  sel_false = mknode(APPLICATION, sel_false, emptylist())
  lock( sel_false )

  $appl_Null = mknode(APPLICATION, $id_Null, emptylist())

  $yyvline = 0
  if VERBOSE then
    $stderr.puts "Exiting initids"
  end
end
# include "parm.h"
# include "stree/ststructs.mh"
# include "../stt/sttdefs.h"

# include "../applinfer/precedence.h"
# load "parm.rb"
#DJDSTOP
# /*
#  *   Initialize the string table to contain various identifiers with
#  * builtin meanings and/or precedences.  Then build trees to correspond
#  * to default signatures, as well as certain other standard subtrees.
#  */
# 
# 
# sttrelptr  indx_assign,      /* precedence 0 */
#            indx_passign,
#            indx_massign,
#            /*   cor             precedence 1 */
#            /*   cand            precedence 2 */
#            /* other operators   precedence 3 */
#            indx_or,          /* precedence 4 */
#            indx_and,         /* precedence 5 */
#            indx_not,         /* precedence 6 */
#            indx_equals,      /* precedence 7 */
#            indx_less,
# 	   indx_le,
# 	   indx_ge,
# 	   indx_ne,
#            indx_greater,
#            indx_plus,        /* precedence 8 */
#            indx_minus,
#            indx_times,       /* precedence 9 */
#            indx_divide,
#            indx_mod,
# 	   indx_pconc,       /* precedence 10 */
# 	   indx_sconc,
#            indx_exp,         /* precedence 11 */
#            indx_deref,       /* precedence 12 */
#            indx_subscr,      /* precedence 13 */
#            indx_New,         /* no precedence */
# 	   indx_ValueOf,
# 	   indx_First,
# 	   indx_Last,
# 	   indx_Pred,
# 	   indx_Succ,
#            indx_Ord,
# 	   indx_OrdInv,
#            indx_Card,
#            indx_In,
#            indx_Out,
# 	   indx_put,
# 	   indx_Callcc,
# 	   indx_size,
# 	   indx_ptr_New,
# 	   indx_init_New,
# 	   indx_empty,
# 	   indx_standard,
# 	   indx_inline;
# 
# int     pend[NLEVELS];   /* pend[n] = last string table entry with precedence */
#                          /* level n                                           */
# sttrelptr indx_Boolean,
# 	  indx_Void,
# 	  indx_true,
# 	  indx_false;
# 	  indx_simple,
# 	  indx_Null,
# 	  indx_Mk;
# sttrelptr indx_Integer,
# 	  indx_Void,
# 	  indx_Array;
# 
# extern   NODE  * sig_assign,
#                * sig_equals,
#                * sig_less,
#                * sig_greater,
#                * sig_New,
#                * sig_const,
# 	       * sig_ValueOf,
# 	       * sig_pconc,
# 	       * sig_sconc,
# 	       * sig_Signature;
# NODE           * val_Boolean,
# 	       * val_Integer,
#                * val_Void;
# NODE 	       * var_Void;
# NODE   * sel_true,  /* Trees for Boolean$true[] and Boolean$false[] */
#        * sel_false,
#        * id_Boolean, /* Note that the last definition field needs to be */
#                      /* set later */
#        * id_Integer,
#        * id_Void,
#        * id_put,
#        * id_ValueOf,
#        * id_New,
#        * id_size,
#        * id_Null,
#        * id_times,
#        * id_plus,
#        * appl_Null;
# 
# extern int  yyvline;  /* initialized here since it is incorporated into */
#                       /* the structures created here.                   */
# #DJDSTART

